/*  xb_copydbf.cpp

XBase64 Software Library

Copyright (c) 1997,2003,2014,2019 Gary A Kunkel

The xb64 software library is covered under 
the terms of the GPL Version 3, 2007 license.

Email Contact:

    xb64-devel@lists.sourceforge.net
    xb64-users@lists.sourceforge.net

*/

#include <xbase.h>
using namespace xb;

int main(int ac,char** av)
{
  if (3 != ac) {
    std::cout <<
    "\nUsage: xb_copydbf filename1 filename2\n"
    "This program copies the structure of one dbf file to another\n";
    return 1;
  }

  char* sFileName = av[1];
  char* tFileName = av[2];

  xbXBase x;
  xbInt16 iRc;
  xbDbf *MyFile = NULL;
  xbDbf *MyNewFile = NULL;

  #ifdef XB_LOGGING_SUPPORT
  x.EnableMsgLogging();
  xbString sMsg;
  sMsg.Sprintf( "Program [%s] initializing...", av[0] );
  x.WriteLogMessage( sMsg );
  #endif

  if(( iRc = x.OpenHighestVersion( sFileName, "", &MyFile )) != XB_NO_ERROR ){
    std::cout << "Could not open file iRc = " << iRc  << " file = "  << sFileName << std::endl;
    x.DisplayError( iRc );
    return 0;
  }

  if(( iRc = MyFile->CopyDbfStructure( MyNewFile, tFileName, tFileName, XB_DONTOVERLAY, XB_SINGLE_USER )) != XB_NO_ERROR ){
      std::cout << "Could not copy file " << tFileName << " Error = " << iRc  << "\n";
      return 3;
  }

  MyFile->Close();
  return 0;
}





