/*  xb_dumpix.cpp

XBase64 Software Library

Copyright (c) 1997,2003,2014 Gary A Kunkel

The xb64 software library is covered under 
the terms of the GPL Version 3, 2007 license.

Email Contact:

    xb64-devel@lists.sourceforge.net
    xb64-users@lists.sourceforge.net

*/


// This program dumps an index file's internal data blocks.
// This program is for index development and debugging purposes


#include <xbase.h>

using namespace xb;

int main( int ac, char ** av ){


  xbInt16 iRc;
  xbXBase x;
  xbDbf   *MyFile = NULL;
  x.EnableMsgLogging();
  x.SetLogSize( 1000000L );

  if( ac <= 1 ) {
    std::cout << "\nUsage: xb_dumphdr filename...\n";
    return 1;
  }
  if(( iRc = x.OpenHighestVersion( av[1], "", &MyFile )) != XB_NO_ERROR ){
    std::cout << "Could not open file iRc = " << iRc  << " file = "  << av[1] << std::endl;
    x.DisplayError( iRc );
    return 0;
  }
  xbIx *pIx = MyFile->GetCurIx();
  if( pIx ){
    // pIx->DumpHeader( 2, 3 );
    pIx->DumpTagBlocks( 2 );
  } else {
    std::cout << av[1] << "No current index found" << std::endl;
  }

  MyFile->Close();
  delete MyFile;

  return 0;
}
