/*  xb_dumprecs.cpp

XBase64 Software Library

Copyright (c) 1997,2003,2014,2019 Gary A Kunkel

The xb64 software library is covered under 
the terms of the GPL Version 3, 2007 license.

Email Contact:

    xb64-devel@lists.sourceforge.net
    xb64-users@lists.sourceforge.net

*/

#include <xbase.h>
using namespace xb;

int main(int ac,char** av)
{
  xbXBase x;
  xbInt16 iRc;
  x.EnableMsgLogging();
  x.SetLogSize( 1000000L );
//  xbUInt32 ulRecCnt = 0;

  if (ac <= 1) {
    std::cout << "Usage: xb_dumprecs filename..." << std::endl;
    return 1;
  }

  xbDbf *MyFile = NULL;
  if(( iRc = x.OpenHighestVersion( av[1], "", &MyFile )) != XB_NO_ERROR ){
    std::cout << "Could not open file iRc = " << iRc  << " file = "  << av[1] << std::endl;
    x.DisplayError( iRc );
    return 0;
  }

//  std::cout << "Processing file sequentially from beginning..." << std::endl;

  xbUInt32 j = 0;
  xbUInt32 ulRecCnt = 0;

  iRc = MyFile->GetRecordCnt( ulRecCnt );

  if( iRc < XB_NO_ERROR )
    return iRc;
  while( j < ulRecCnt ){
    if( j == 0 )
      iRc = MyFile->DumpRecord(++j, 2, 2 );
    else
      iRc = MyFile->DumpRecord(++j, 2, 1 );
    if( iRc != XB_NO_ERROR ){
      x.DisplayError( iRc );
      return 1;
    }
  }
//  std::cout << j << " Records written to logile" << std::endl;
  MyFile->Close();
  return 0;
}
