/*  xb_deletall.cpp

XBase64 Software Library

Copyright (c) 1997,2003,2014,2017 Gary A Kunkel

The xb64 software library is covered under 
the terms of the GPL Version 3, 2007 license.

Email Contact:

    xb64-devel@lists.sourceforge.net
    xb64-users@lists.sourceforge.net



This program sets the delete flag on all records in a dbf file

*/


#include <xbase.h>


using namespace xb;

int main(int ac,char** av)
{

  xbXBase x;
  xbDbf *MyFile = NULL;
  xbInt16 iRc = 0;

  if (ac <= 1) {
    std::cout << "\nUsage: xb_deletall filename...\n";
    return 1;
  }

  if(( iRc = x.OpenHighestVersion( av[1], "", &MyFile )) != XB_NO_ERROR ){
    std::cout << "Could not open file iRc = " << iRc  << " file = "  << av[1] << std::endl;
    x.DisplayError( iRc );
    return 0;
  }

  iRc = MyFile->UndeleteAllRecords(); 
  if( iRc != XB_NO_ERROR ) {
    std::cout << "Error Undeleting all records - database ==> "  << av[1]  << "\n";
    std::cout << " Return Code = " << iRc;
  }
  MyFile->Close();
  delete MyFile;
  std::cout << "\nDone...\n\n";
  
  return 0;
}