/*  xb_zap.cpp

XBase64 Software Library

Copyright (c) 1997,2003,2014,2017 Gary A Kunkel

The xb64 software library is covered under 
the terms of the GPL Version 3, 2007 license.

Email Contact:

    xb64-devel@lists.sourceforge.net
    xb64-users@lists.sourceforge.net

*/

#include <xbase.h>
using namespace xb;

int main(int ac,char** av)
{
  if (ac <= 1) {
     std::cout << 
           "\nUsage: zap filename...\n"
           "\nThis program does not automatically reindex any indices."
           "\nUse the reindex program to reindex any indexes associated"
           "\nwith the database, or build your own program which executes "
           "\nthe PackDatabase() method after opening all the index files "
           "\nassociated with the database.\n\n"
           ;
     return 1;
  }

  xbXBase x;
  xbInt16 iRc;
  xbDbf *MyFile = NULL;

  if(( iRc = x.OpenHighestVersion( av[1], "", &MyFile )) != XB_NO_ERROR ){
    std::cout << "Could not open file " << av[1] << std::endl;
    return iRc;
  }

  if(( iRc = MyFile->Zap()) != XB_NO_ERROR ) {
    std::cout << "\nError packing DBF database ==> " << av[1] << std::endl;
    std::cout << " Return Code = " << iRc << std::endl;
  }
  MyFile->Close();
  delete MyFile;

  std::cout << "\nZap Database complete..." << std::endl;
  return 0;
}
